/*******************
VARIABLES
*******************/
var lastModified = "2018-06-26";
var lastUploaded = "2018-06-26";
var templateVersion = "2.0.24";
var adId, rnd, uid;
var sdkData;
var isMRAID;
var isLandscape;
var viewportWidth;
var viewportHeight;
var adWidth;
var adHeight;
var adTopPercentage;
var adBottomPercentage;
var adVisiblePercentage;
var sizeCheckerTimer

var footer;
var logo;
var cta_area;
var cloud_1;
var cloud_2;
var sun;
var hands;

/*******************
INITIALIZATION
*******************/
function checkIfAdKitReady(event) {
	try {
		if (window.localPreview) {
			window.initializeLocalPreview(); //in localPreview.js
			initializeCreative();
			return;
		}
	}
	catch (e) {}

	adkit.onReady(initializeCreative);
}

function initializeCreative() {
	// so messaging can work in safe frames we need to bind the events that are present in the event manager.
	EBG.pm.bind("sendCreativeId", function () {
		eventManager.apply(this, arguments);
	}, this);
	EBG.pm.bind("eventCallback", function () {
		eventManager.apply(this, arguments);
	}, this);

	//Workaround (from QB6573) for Async EB Load where Modernizr isn't properly initialized
	typeof Modernizr == "object" && (Modernizr.touch = Modernizr.touch || "ontouchstart" in window);

	initializeGlobalVariables();
	window.registerInteraction = function () {}; //overwrite rI function because it will never actually be called
	addEventListeners();
}

function initializeGlobalVariables() {
	adId = EB._adConfig.adId;
	rnd = EB._adConfig.rnd;
	uid = EB._adConfig.uid;

	if (!isMRAID) {
		sdkData = EB.getSDKData();
		isMRAID = sdkData !== null && sdkData.SDKType === "MRAID";
	}	
	// how to add widget on placement level that will scroll with the ad
	/*
	widget = new Widget({
		name: "",			[required] name of the widget
		width: "",			[required] widget width in px
		height: "",			[required] widget height in px	
		top: "",			[required / optional] widget position from ad top in px, must specify either top or bottom
		left: "",			[required / optional] widget position from ad left in px, must specify either left or right
		bottom: "",			[required / optional] widget position from ad bottom in px, must specify either top or bottom
		right: "",			[required / optional] widget position from ad right in px, must specify either left or right
		html: "",			[optional] html code for widget content	
		asset: "",			[optional] asset from workspace root, will treat as widget background
		hover: "",			[optional] asset from workspace root, will treat as widget background when mouse over the widget
		css: "",			[optional] widget styles		
		callback: "",		[optional] function to be called when widget clicked, mouse cursor set to pointer automatically when callback is set
		inapp: "",			[optional] decide if widget render when ad served in app or not, default is true
		effects: [			[optional] effect(s) of the widget
			{
				on : "scroll",			[required] when to change											// scroll, resize
				scrollFrom: 0,			[optional] number of percentage of the scrolling when effect start, default is 0, only take affect when on set to scroll
				scrollTo: 100,			[optional] number of percentage of the scrolling when effect end, default is 100, only take affect when on set to scroll
				changeProperty: "left",	[required] what property to be changed	
				changeFrom: "0%",		[optional] value of property when change started					// in px or %, will use "changeTo" value if "changeFrom" is not specified
				changeTo: "100%",		[required] value of property when change ended						// in px or %
				minChangeTo: -1,		[optional] minimum changeTo value in number of px					// in px, set to -1 for no minimum
				maxChangeTo: -1,		[optional] maximum changeTo value in number of px					// in px, set to -1 for no maximum
				animation: {			[optional] by default is false										// true or false
					duration: 1.25,		[optional] override animation duration in number of second, 		// 1.25
					easing: "ease-out"	[optional] override animaiton easing type, default is "ease-out"	// ease-out, ease, linear, ease-in, ease-in-out
				},
				width: "auto"			[optional] define what to be used for the width if change is height	// in px or %, or "nochange", or "auto", only take affect when change set to height
				height: "auto"			[optional] define what to be used for the height if change is width	// in px or %, or "nochange", or "auto", only take affect when change set to width
			}
		]
	});
	*/
	
	// cloud 1
	cloud_1 = new Widget({
		name: "cloud_1",
		top: "30px",
		left: "-200px",
		width: "200px",
		height: "130px",
		asset: "panels/expand/images/cloud.png",
		css: "opacity: 0.9;",
		effects: [
			{
				on: "scroll",
				changeProperty: "left",
				changeFrom: "-20%",
				changeTo: "90%"
			}
		]
	});

	// cloud 2
	cloud_2 = new Widget({
		name: "cloud_2",
		top: "60px",
		left: "-900px",
		width: "900px",
		height: "584px",
		asset: "panels/expand/images/cloud.png",
		css: "opacity: 0.7;",
		effects: [
			{
				on: "scroll",
				changeProperty: "left",	
				changeFrom: "-60%",
				changeTo: "80%"
			}
		]
	});
	
	// sun
	sun = new Widget({
		name: "sun",
		top: "0px",
		right: "100px",
		width: "325px",
		height: "210px",
		asset: "panels/expand/images/sun_with_cloud.png",
		css: "opacity: 0;",
		effects: [		
			{
				on: "scroll",
				scrollFrom: 90,
				scrollTo: 100,				
				changeProperty: "opacity",
				changeFrom: "0",
				changeTo: "0.7"
			}			
		]
	});
	
	// hands
	hands = new Widget({
		name: "hands",
		bottom: "0px",
		right: "0px",
		width: "362px",
		height: "400px",
		asset: "panels/expand/images/hands.png",
		effects: [
			{
				on: "resize",
				changeProperty: "height",
				changeTo: "100%"
			}
		]
	});	

	// footer
	footer = new Widget({
		name: "footer",
		bottom: "0px",
		left: "0px",
		width: "320px",
		height: "60px",
		css: "background-color: rgba(188, 200, 225, 0.5);",
		effects: [
			{
				on: "resize",
				changeProperty: "width",
				changeTo: "100%",
				height: "nochange"
			}
		]
	});	
	
	// logo
	logo = new Widget({
		name: "logo",
		bottom: "5px",
		left: "10px",
		width: "118px",
		height: "53px",
		asset: "panels/expand/images/logo_dark_blue.svg" // asset from workspace root, will treat as widget background
	});

	// clickthrough
	cta_area = new Widget({
		name: "cta_area",
		top: "0px",
		left: "-430px",
		width: "430px",
		height: "300px",
		asset: "panels/expand/images/clickthrough.png",
		callback: "handleClickthroughButtonClick",
		effects: [
			{
				on: "scroll",
				scrollFrom: 20,
				scrollTo: 40,			
				changeProperty: "left",
				changeFrom: "-430px",
				changeTo: "100px",
				maxChangeTo: "0px"
			},		
			{
				on: "resize",
				changeProperty: "width",
				changeTo: "30%",
				minChangeTo: "200px",
				maxChangeTo: "430px"
			}
		]		
	});	
	
	panelLoaded();
	positionAdElements();
	setTimeout(createTextBar, 1500); // add delay because the style will missing in some android device if without this delay
}

function addEventListeners() {	
	// format events, please do not remove or alter
	window.addEventListener("resize", handleResize, false);
	window.addEventListener("message", onMessageReceived, false);
	if (EB.API.os.mobile || isTouchSupported()) {
		window.addEventListener(window.navigator.msPointerEnabled ? "MSPointerDown" : "touchstart", handleTouchStart, false);
		window.addEventListener(window.navigator.msPointerEnabled ? "MSPointerUp" : "touchend", handleTouchEnd, false);
	}
	window.addEventListener("mouseup", handleTouchEnd, false);
	document.addEventListener("wheel", handleWheelScroll, false);
	document.addEventListener("keydown", handleKeyDown, false);
	document.addEventListener("touchmove", handleKeyDown, false);
}

/*******************
EVENT HANDLERS
*******************/
function handleClickthroughButtonClick() {
	EB.clickthrough(); // default click through
}

function handleCloseButtonClick() {
	EB.collapse();
}
function handleResize() {
	if (typeof positionAdElements === "function") {
		positionAdElements();
	}
}

function handleBeginFullScreen() {
	// format handler, please do not remove or alter
	sendMessage("creativeEnterFullScreen", {});
}

function handleEndFullScreen() {
	// format handler, please do not remove or alter	
	sendMessage("creativeExitFullScreen", {});
}

function handleFullScreenChange() {
	// format handler, please do not remove or alter
	if (document.webkitIsFullScreen) {
		handleBeginFullScreen();
	}
	else {
		handleEndFullScreen();
	}
}
function handleKeyDown() {
	handleWheelScroll();
}

function handleWheelScroll() {
	// format handler, please do not remove or alter
	sendMessage("creativeWheelScroll", {});
}

function handleTouchStart(e) {
	// format handler, please do not remove or alter
	if (typeof e !== "undefined" && isTouchEvent(e)) {
		sendMessage("creativeTouchStart", getTouchPosition(e));
	}
}

function handleTouchEnd(e) {
	// format handler, please do not remove or alter	
	if (typeof e !== "undefined" && isTouchEvent(e)) {
		sendMessage("creativeTouchEnd", getTouchPosition(e));
	}
}

/*******************
CREATIVE FUNCTIONS
*******************/
function snapToFullscreenMode() {
	/* code added here can be triggered when ad snapped into fullscreen mode*/
	
	/* code ends here, please do not edit or remvoe code below */
	sendMessage("snapToFullscreenMode", {});
	EB.userActionCounter("snapToFS");
}

function exitFullscreenMode() {
	/* code added here can be triggered when ad otu of fullscreen mode*/
	
	/* code ends here, please do not edit or remvoe code below */
	sendMessage("exitFullscreenMode", {});
	EB.userActionCounter("exitFS");
}

function adScrollIn() {
	/* code added here can be triggered when ad scrolls in viewport */
}

function adScrollAway() {
	/* code added here can be triggered when ad scrolls out of viewport */
}

function adSnapIn() {
	/* code added here can be triggered when ad snapped in */
}

function adSnapOut() {
	/* code added here can be triggered when ad snapped out */
}

function adCollapsed() {
	/* code added here can be triggered when ad collapsed */
}

function onPageScroll(data) {
	/* code added here can be triggered when page scrolled */

	/* code ends here, please do not edit or remvoe code below */
	viewportWidth = data.viewPortMetrics.width;
	viewportHeight = data.viewPortMetrics.height;
	adWidth = data.adMetrics.width;
	adHeight = data.adMetrics.height;
	adTopPercentage = data.adMetrics.topPercentage;
	adBottomPercentage = data.adMetrics.bottomPercentage;
	adVisiblePercentage = data.adMetrics.visiblePercentage;
	isLandscape = viewportWidth > viewportHeight;
	positionAdElements();
}

function positionAdElements() {
	/* add code here for the html elements to be reiszed or repositioned */
	/* use the following values
		viewportWidth 			integer in number of pixels
		viewportHeight			integer in number of pixels
		adWidth					integer in number of pixels
		adHeight				integer in number of pixels
		adTopPercentage			integer in number of percentage, based on top edge of the ad / viewport height
		adBottomPercentage		integer in number of percentage, based on bottom edge of the ad / viewport height
		adVisiblePercentage		integer in number of percentage, percentage viewable ad
	*/
	
	
	/* code ends here, please do not edit or remvoe code below */
	if (EB.API.getCustomVar("mdChangeImageOnOrientation")) {
		EB.API.setStyle(document.body, {
			backgroundImage: "url(images/background_" + (isLandscape ? "landscape" : "portrait") + ".jpg)"
		});
	}
	// reposition again after 500ms on Android device because some android device may not report size correctly
	if (EB.API.os.android) {
		if (sizeCheckerTimer) {
			clearTimeout(sizeCheckerTimer);
		}
		sizeCheckerTimer = setTimeout(function () {
			if (parseInt(document.body.style.width) !== window.innerWidth || parseInt(document.body.style.height) !== window.innerHeight) {
				positionAdElements();
			}
		}, 500);
	}
}

/*******************
UTILITIES
*******************/
function panelLoaded() {
	sendMessage("panelIsLoaded", {});
}

function isTouchSupported() {
	var msTouchEnabled = window.navigator.msMaxTouchPoints;
	var generalTouchEnabled = "ontouchstart" in document.createElement("div");

	if (msTouchEnabled || generalTouchEnabled) {
		return true;
	}
	return false;
}

function isTouchEvent(e) {
	var isTouchEvent = false;
	if (e.hasOwnProperty("pointerType")) {
		if (e.pointertype.indexOf("touch") !== -1) {
			isTouchEvent = true;
		}
	}
	else if (e.hasOwnProperty("type")) {
		if (e.type.indexOf("touch") !== -1) {
			isTouchEvent = true;
		}
	}
	return isTouchEvent;
}

function getTouchPosition(e) {
	if (window.navigator.msPointerEnabled) {
		return {
			x: e.pageX || e.targetTouches[0].pageX,
			y: e.pageY || e.targetTouches[0].pageY
		};
	}
	else {
		return {
			x: e.changedTouches[0].pageX,
			y: e.changedTouches[0].pageY
		};
	}
}

function getTopBarHeight() {
	return EB.API.getCustomVar("mdDisplayTopBar") ? EB.API.getCustomVar("mdTopBarHeight") : 0;
}

function getBottomBarHeight() {
	return EB.API.getCustomVar("mdDisplayBottomBar") ? EB.API.getCustomVar("mdBottomBarHeight") : 0;
}

function getBooleanOption(options) {
	var opt = options.toString().split("");
	return {
		desktop: Boolean(opt[0] * 1),
		ios: Boolean(opt[1] * 1),
		android: Boolean(opt[2] * 1),
		windowsphone: Boolean(opt[3] * 1)
	};
}

function resizeTextBar() {
	var textBars = document.getElementsByClassName("text-bar-div");
	for (var i = 0; i < textBars.length; i++) {
		EB.API.setStyle(textBars[i], {
			width: EBG.px(window.innerWidth)
		});
	}
}

function createTextBar() {
	if (parseInt(EB.API.getCustomVar("mdTopBottomBarInCreative")) === 0) {
		return;
	}
	else {
		var barInCreativeEnabled = getBooleanOption(EB.API.getCustomVar("mdTopBottomBarInCreative"));
		if ((!EB.API.os.mobile && barInCreativeEnabled.desktop) ||
			(EB.API.os.ios && barInCreativeEnabled.ios) ||
			(EB.API.os.android && barInCreativeEnabled.android) ||
			(EB.API.os.windowsphone && barInCreativeEnabled.windowsphone)) {
			// create top text bar
			if (EB.API.getCustomVar("mdDisplayTopBar")) {
				if (document.getElementsByClassName("text-bar-div top").length > 0) {
					return;
				}
				var topBarDiv = document.createElement("div");
				document.body.appendChild(topBarDiv);
				topBarDiv.setAttribute("class", "text-bar-div top");
				topBarDiv.setAttribute("style", EB.API.getCustomVar("mdTopBarLabelStyle"));
				topBarDiv.innerHTML = EB.API.getCustomVar("mdTopBarLabel");
				EB.API.setStyle(topBarDiv, {
					position: "absolute",
					top: "0px",
					left: "0px",
					width: EBG.px(window.innerWidth),
					height: EBG.px(EB.API.getCustomVar("mdTopBarHeight")),
					backgroundColor: EB.API.getCustomVar("mdTopBarColor"),
					lineHeight: EBG.px(EB.API.getCustomVar("mdTopBarHeight")),
					zIndex: EB.API.getStyle(adContainer, "zIndex") + 1
				});
			}
			if (EB.API.getCustomVar("mdDisplayBottomBar")) {
				if (document.getElementsByClassName("text-bar-div bottom").length > 0) {
					return;
				}
				var bottomBarDiv = document.createElement("div");
				document.body.appendChild(bottomBarDiv);
				bottomBarDiv.setAttribute("class", "text-bar-div bottom");
				bottomBarDiv.setAttribute("style", EB.API.getCustomVar("mdBottomBarLabelStyle"));
				bottomBarDiv.innerHTML = EB.API.getCustomVar("mdBottomBarLabel");
				EB.API.setStyle(bottomBarDiv, {
					position: "absolute",
					bottom: "0px",
					left: "0px",
					width: EBG.px(window.innerWidth),
					height: EBG.px(EB.API.getCustomVar("mdBottomBarHeight")),
					backgroundColor: EB.API.getCustomVar("mdBottomBarColor"),
					lineHeight: EBG.px(EB.API.getCustomVar("mdBottomBarHeight")),
					zIndex: EB.API.getStyle(adContainer, "zIndex") + 1
				});
			}
			window.addEventListener("resize", resizeTextBar, false);
		}
	}
}

function Widget(widget) {
	this.widgetData = widget;
	sendMessage("addWidget", {
		widget: widget
	});
}

Widget.prototype = {
	show: function () {
		sendMessage("widgetHandler", {
			action: "show",
			widgetData: this.widgetData
		});
	},
	hide: function () {
		sendMessage("widgetHandler", {
			action: "hide",
			widgetData: this.widgetData
		});
	},
	remove: function () {
		sendMessage("widgetHandler", {
			action: "remove",
			widgetData: this.widgetData
		});
	},	
	resizeTo: function (size) {
		var widgetData = this.widgetData;
		widgetData.size = size;		
		sendMessage("widgetHandler", {
			action: "resizeTo",
			widgetData: widgetData
		});
	},
	moveTo: function (loc) {
		var widgetData = this.widgetData;
		widgetData.loc = loc;
		sendMessage("widgetHandler", {
			action: "moveTo",
			widgetData: widgetData
		});
	}
};

function onMessageReceived(event) {
	try {
		var data = JSON.parse(event.data);
		if (typeof window[data.type] === "function") {
			window[data.type](data.data);
		}
	}
	catch (error) {}
}

/*********************************
HTML5 Event System - Do Not Modify
*********************************/
var listenerQueue;
var creativeIFrameId;

function sendMessage(type, data) {

	//note: the message type we're sending is also the name of the function inside
	//		the custom script's messageHandlers object, so the case must match.

	if (!data.type) data.type = type;
	EB._sendMessage(type, data);
}

function addCustomScriptEventListener(eventName, callback, interAd) {
	listenerQueue = listenerQueue || {};
	var data = {
		uid: uid,
		listenerId: Math.ceil(Math.random() * 1000000000),
		eventName: eventName,
		interAd: !!(interAd),
		creativeIFrameId: creativeIFrameId
	};
	sendMessage("addCustomScriptEventListener", data);
	data.callback = callback;
	listenerQueue[data.listenerId] = data;
	return data.listenerId;
}

function dispatchCustomScriptEvent(eventName, params) {
	params = params || {};
	params.uid = uid;
	params.eventName = eventName;
	params.creativeIFrameId = creativeIFrameId;
	sendMessage("dispatchCustomScriptEvent", params);
}

function removeCustomScriptEventListener(listenerId) {
	var params = {
		uid: uid,
		listenerId: listenerId,
		creativeIFrameId: creativeIFrameId
	};

	sendMessage("removeCustomScriptEventListener", params);
	if (listenerQueue[listenerId])
		delete listenerQueue[listenerId];
}

function eventManager(event) {

	var msg;
	if (typeof event == "object" && event.data) {
		msg = JSON.parse(event.data);

	}
	else {
		// this is safe frame.
		msg = {
			type: event.type,
			data: event
		};
	}
	if (msg.type && msg.data && (!uid || (msg.data.uid && msg.data.uid == uid))) {
		switch (msg.type) {
		case "sendCreativeId":
			creativeIFrameId = msg.data.creativeIFrameId;
			addCustomScriptEventListener('pageScroll', onPageScroll);
			sendMessage("dispatchScrollPos", {
				uid: uid
			});
			if (creativeContainerReady)
				creativeContainerReady();
			break;
		case "eventCallback": // Handle Callback
			var list = msg.data.listenerIds;
			var length = list.length;
			for (var i = 0; i < length; i++) {
				try {
					var t = listenerQueue[list[i]];
					if (!t) continue;
					t.callback(msg.data);
				}
				catch (e) {}
			}
			break;
		}
	}
}

window.addEventListener("message", function () {
	try {
		eventManager.apply(this, arguments);
	}
	catch (e) {}
}, false);
/*************************************
End HTML5 Event System - Do Not Modify
*************************************/

window.addEventListener("load", checkIfAdKitReady);